/***************************************************************************
 *   Copyright (C) 2003 by Thomas E. Bruno                                 *
 *   oss@vwords.com                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#undef TRUE
#undef FALSE
#define TRUE 1              /* defined for simple error checking */
#define FALSE 0             /* defined for simple error checking */
#define SUCCESS 1           /* defined for simple error checking */

#define PROGNAME "poweracpid"
#define EVENTFILE "/proc/acpi/event"
#define ACPI_SOCKETFILE "/var/run/acpid.socket"
#define ACPI_SOCKETMODE		0666
#define POWERACPIDVERSION "0.2"

 int debug_flag;
static const char *socketfile = ACPI_SOCKETFILE;
static const char *socketgroup;
static mode_t socketmode = ACPI_SOCKETMODE;
static int nosocket;

/*   for Cpu Control */

typedef struct cpustats {
	unsigned long long user;
	unsigned long long mynice;
	unsigned long long system;
	unsigned long long idle;
} cpustats_t;

typedef struct cpuinfo {
	unsigned int cpuid;
	unsigned int nspeeds;
	unsigned int max_speed;
	unsigned int min_speed;
	unsigned int current_speed;
	cpustats_t *last_reading;
	cpustats_t *reading;
} cpuinfo_t;


struct acpi_event_cmd {
            char event[64];
            char device[64];
            char id[64];
            char info[64];
               };