#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <unistd.h>
#include <sys/un.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <grp.h>
#include <stddef.h>

#include "global.h"
#include "poweracpid.h"
#include "system_func.h"



int main(int argc, char *argv[])
{
    int poll_errck; 				/* used to detect poll error ** not complete */
    int child_errck;				/* used to check fork for error */
    int event_fileFD;				/* Event file handle */
    int socket_FD;
    int event_count = 0;			/* event counter so I know what's going on */
    char *event;				/* Used to store the event */
    struct acpi_event_cmd formatted_event_cmd, *p;  /* used to store formated event */
    p = &formatted_event_cmd;

    debug_flag = 0;

handle_cmdline(argc,argv);


/* forks process to daemonize  */
    event_fileFD = open(EVENTFILE, O_RDONLY);
    if(event_fileFD < 0){
        printf("%s: was unable to open event file!\n",PROGNAME);
        exit(EXIT_FAILURE);
        }

    socket_FD = ud_create_socket(socketfile);
    if(socket_FD < 0){
        printf("%s: was unable to open socket file!\n",PROGNAME);
        exit(EXIT_FAILURE);
        }

    fcntl(socket_FD, F_SETFD, FD_CLOEXEC);
    chmod(socketfile, socketmode);
    if (socketgroup) {
	struct group *gr;
	struct stat buf;
	gr = getgrnam(socketgroup);
    }


    if(debug_flag != TRUE){
        printf("Switching to daemon mode\n\n\n");
        child_errck = daemonize();
        }
   if(debug_flag != child_errck){
        printf("Not in daemon Mode, Debug mode started.\n");
        }

signal(SIGPIPE, SIG_IGN);
/* start of main system loop */

    while(1)
	{
        int count_eventholder = 0;
	/* used for detecting events */
	struct pollfd acpi_event_detect[2];
	acpi_event_detect[0].fd = event_fileFD;
	acpi_event_detect[0].events = POLLIN;
	count_eventholder++;

        if (!nosocket) {
	acpi_event_detect[1].fd = socket_FD;
	acpi_event_detect[1].events = POLLIN;
	count_eventholder++;
        }

	/* starting poll for file, still need to implement error check */
	/* if poll_errck < 0 error */
	poll_errck = poll(acpi_event_detect,count_eventholder,-1);
/*	if(poll_errck < 0) {
        	printf("There was a poll() error\n");
                exit(EXIT_FAILURE);
                }
*/

/*   THIS IS WHAT TAKES PLACE IF AN EVENT OCCURS */

	if (acpi_event_detect[0].revents) {
         printf("event\n");
	 formatted_event_cmd = read_event_file(event_fileFD);
         printf("%s %s %s %s\n This Is Real",p->event,p->device,p->id,p->info);


	}


        if (acpi_event_detect[1].revents) {
/*  More barrowed code from acpid, looking to replace */

                        int cli_fd;
			struct ucred creds;
			char buf[32];

			/* this shouldn't happen */
			if (!acpi_event_detect[1].revents & POLLIN) {
				printf("odd, poll set flags 0x%x\n",
					acpi_event_detect[1].revents);
				continue;
			}

			/* accept and add to our lists */
			cli_fd = ud_accept(socket_FD);
			if (cli_fd < 0) { printf("error\n");
                        		exit(EXIT_FAILURE);
                                        }
                                printf("client connected from %s\n", buf);
		}

    }


return (EXIT_SUCCESS);
}


void set_cputo_performance(void)
{
system("echo performance > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor");
printf("System set to powersave\n\n");
}

void set_cputo_powersave(void)
{
system("echo powersave > /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor");
printf("System set to powersave\n\n");
}
